package com.malk.kuaikeli.controller;

import com.alibaba.excel.EasyExcel;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.malk.kuaikeli.entity.SupplierMaterial;
import com.malk.kuaikeli.listener.SupplierMaterialDataListener;
import com.malk.kuaikeli.service.SupplierMaterialService;
import com.malk.server.common.McR;
import com.malk.server.common.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/suppliermaterial")
public class SupplierMaterialController {

    @Autowired
    private SupplierMaterialService supplierMaterialService;

    @PostMapping("/upload")
    public McR upload(@RequestParam(value="file")MultipartFile file) throws IOException {
        if(file.isEmpty()||file.getSize()<1){
            return McR.errorParam("文件不存在！");
        }
        if(!file.getOriginalFilename().endsWith("xlsx")&&!file.getOriginalFilename().endsWith("xls")) {
            return McR.errorParam("文件格式错误！");
        }
        EasyExcel.read(file.getInputStream(), SupplierMaterial.class, new SupplierMaterialDataListener(supplierMaterialService)).sheet().doRead();
        return McR.success();
    }

    @GetMapping("/sync")
    public McR sync(String startDateTime){
        supplierMaterialService.sync(startDateTime);
        return McR.success();
    }

    @GetMapping("/getList")
    public McR selectList(@RequestParam(defaultValue = "1") Integer current,
                          @RequestParam(defaultValue = "10") Integer size){
        return supplierMaterialService.getList(current,size);
    }


}
